/* *****************************************************************
 * ITS 332 Information Technology II (Networking) Lab
 * Semester 2, 2008
 * SIIT
 *
 * Client/Server Programming Lab
 * File: example.c
 * Date: 22 Jan 2009
 * Version: 1.0
 *
 * Description: 
 * Demonstrate C functions useful for client/server assignment
 *
 * Usage:
 * example
 *
 * ***************************************************************** */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>	// Note the time header file is needed 

int main(int argc, char *argv[])
{
	FILE *infile;	
	FILE *outfile;
	char infilename[255];
	char outfilename[255];
	char line[255];
	char test[255];
	char word1[255];
	char word2[255];
	int i;
	time_t now; 
	struct sockaddr_in ip_addr;
	char *address;

/* ================================================================= */
/* EXAMPLE 0: Command line arguments */
/* ================================================================= */ 
	/* argc is the count of input arguments */
	printf("argc: %d\n",argc);

	/* argv is an array of strings, each string containin an input
           argument. argv[0] is the name of the program. */
	if (argc == 1) {
		printf("argv[0]: %s\n",argv[0]);
	} else if (argc == 2) {
		printf("argv[0]: %s\n",argv[0]);
		printf("argv[1]: %s\n",argv[1]);
	} else if (argc == 3) {		
		printf("argv[0]: %s\n",argv[0]);
		printf("argv[1]: %s\n",argv[1]);
		printf("argv[2]: %s\n",argv[2]);
	} else {
		printf("argv[0]: %s\n",argv[0]);
		printf(" ... and more\n");
	}
	
/* ================================================================= */
/* EXAMPLE 1: Opening and reading data from a file */
/* ================================================================= */ 
	/* Reading input from the user using scanf */
	printf("Please enter the filename to open: ");
	scanf("%s", (char *) &infilename);

	/* Open a file for reading (r) */
	infile = fopen(infilename,"r");
	if (infile == NULL) {
		fprintf(stderr,"Error in opening file %s\n", infilename);
		exit(0);
	}

	/* Loop through, reading line by line and printing to screen */
	/* Note that feof tests if the End-of-File has been reached, */
	/* and if so, returns a non-zero value */
	fgets((char *) line,255,infile);
	while (feof(infile)==0) {
		printf("%s",line);
		fgets((char *) line,255,infile);		
	}

	/* Close the file */
	fclose(infile);

/* ================================================================= */
/* EXAMPLE 2: Using sscanf to split strings */
/* ================================================================= */ 
	/* Use sscanf to split a string into multiple strings */
	strcpy(test,"Hello Steve");
	i = sscanf(test,"%s %s\n",(char *) &word1, (char *) &word2);
	/* Note that sscanf returns the number of items matched */
	if (i!=2) {
		fprintf(stderr,"Error in using sscanf\n");
		exit(0);
	}
	printf("Word 1: %s\nWord 2: %s\n", word1, word2);

/* ================================================================= */
/* EXAMPLE 3: Printing the current time */
/* ================================================================= */ 
	/* Set the now variable to be the current data/time */
	time(&now); 
	/* ctime() returns a string indicating the time of the input variable */
	printf("The time is: %s",ctime(&now)); 
	
/* ================================================================= */
/* EXAMPLE 4: Printing an IP address */
/* ================================================================= */ 
	/* The following 4 lines are already in your client.c/server.c */
	/* You shouldn't need to add these */
	bzero((char *) &ip_addr, sizeof(ip_addr));
	ip_addr.sin_family = AF_INET; /* Protocol family: Internet */
	ip_addr.sin_addr.s_addr = inet_addr("10.0.0.1"); 
	ip_addr.sin_port = htons(40000); /* Port number */

	/* This is what you need to convert an IP address to a string */
	address = (char *) inet_ntoa(ip_addr.sin_addr);
	printf("IP address is: %s\n",address);

	return 0;
}
